Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12468)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12468)
@@ -0,0 +1,186 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Data.Linq;
+using System.Transactions;
+using HeuristicLab.Services.Hive.DataAccess.Daos;
+using HeuristicLab.Services.Hive.DataAccess.Daos.HiveStatistics;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+
+namespace HeuristicLab.Services.Hive.DataAccess.Manager {
+  public class PersistenceManager : IPersistenceManager {
+    private readonly DataContext dataContext;
+    public DataContext DataContext {
+      get { return dataContext; }
+    }
+
+    #region Hive daos
+    public AssignedResourceDao AssignedResourceDao {
+      get { return new AssignedResourceDao(dataContext); }
+    }
+
+    public DowntimeDao DowntimeDao {
+      get { return new DowntimeDao(dataContext); }
+    }
+
+    public JobDao JobDao {
+      get { return new JobDao(dataContext); }
+    }
+
+    public JobPermissionDao JobPermissionDao {
+      get { return new JobPermissionDao(dataContext); }
+    }
+
+    public LifecycleDao LifecycleDao {
+      get { return new LifecycleDao(dataContext); }
+    }
+
+    public PluginDao PluginDao {
+      get { return new PluginDao(dataContext); }
+    }
+
+    public PluginDataDao PluginDataDao {
+      get { return new PluginDataDao(dataContext); }
+    }
+
+    public RequiredPluginDao RequiredPluginDao {
+      get { return new RequiredPluginDao(dataContext); }
+    }
+
+    public ResourceDao ResourceDao {
+      get { return new ResourceDao(dataContext); }
+    }
+
+    public ResourcePermissionDao ResourcePermissionDao {
+      get { return new ResourcePermissionDao(dataContext); }
+    }
+
+    public SlaveDao SlaveDao {
+      get { return new SlaveDao(dataContext); }
+    }
+
+    public SlaveGroupDao SlaveGroupDao {
+      get { return new SlaveGroupDao(dataContext); }
+    }
+
+    public StateLogDao StateLogDao {
+      get { return new StateLogDao(dataContext); }
+    }
+
+    public TaskDao TaskDao {
+      get { return new TaskDao(dataContext); }
+    }
+
+    public TaskDataDao TaskDataDao {
+      get { return new TaskDataDao(dataContext); }
+    }
+
+    public UserPriorityDao UserPriorityDao {
+      get { return new UserPriorityDao(dataContext); }
+    }
+    #endregion
+
+    #region HiveStatistics daos
+    public DimClientDao DimClientDao {
+      get { return new DimClientDao(dataContext); }
+    }
+
+    public DimJobDao DimJobDao {
+      get { return new DimJobDao(dataContext); }
+    }
+
+    public DimTimeDao DimTimeDao {
+      get { return new DimTimeDao(dataContext); }
+    }
+
+    public DimUserDao DimUserDao {
+      get { return new DimUserDao(dataContext); }
+    }
+
+    public FactClientInfoDao FactClientInfoDao {
+      get { return new FactClientInfoDao(dataContext); }
+    }
+
+    public FactTaskDao FactTaskDao {
+      get { return new FactTaskDao(dataContext); }
+    }
+    #endregion
+
+    public PersistenceManager(bool longRunning = false) {
+      var context = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
+      if (longRunning) context.CommandTimeout = (int)Settings.Default.LongRunningDatabaseCommandTimeout.TotalSeconds;
+      dataContext = context;
+    }
+
+    #region Transaction management
+    public void UseTransaction(Action call, bool repeatableRead = false, bool longRunning = false) {
+      UseTransaction<object>(() => {
+        call();
+        return null;
+      });
+    }
+
+    public T UseTransaction<T>(Func<T> call, bool repeatableRead = false, bool longRunning = false) {
+      int n = 10;
+      while (n > 0) {
+        TransactionScope transaction = CreateTransaction(repeatableRead, longRunning);
+        try {
+          T result = call();
+          transaction.Complete();
+          return result;
+        }
+        catch (System.Data.SqlClient.SqlException e) {
+          n--; // probably deadlock situation, let it roll back and repeat the transaction n times
+          LogFactory.GetLogger(typeof(TransactionManager).Namespace).Log(string.Format("Exception occured, repeating transaction {0} more times. Details: {1}", n, e.ToString()));
+          if (n <= 0) throw;
+        }
+        finally {
+          transaction.Dispose();
+        }
+      }
+      throw new Exception("Transaction couldn't be completed.");
+    }
+
+    private static TransactionScope CreateTransaction(bool repeatableRead, bool longRunning) {
+      var options = new TransactionOptions {
+        IsolationLevel = repeatableRead ? IsolationLevel.RepeatableRead : IsolationLevel.ReadUncommitted
+      };
+      if (longRunning) {
+        options.Timeout = Settings.Default.LongRunningDatabaseCommandTimeout;
+      }
+      return new TransactionScope(TransactionScopeOption.Required, options);
+    }
+    #endregion
+
+    public void SubmitChanges() {
+      if (dataContext != null) {
+        dataContext.SubmitChanges();
+      }
+    }
+
+    public void Dispose() {
+      if (dataContext != null) {
+        dataContext.Dispose();
+      }
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/TransactionManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/TransactionManager.cs	(revision 12468)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/TransactionManager.cs	(revision 12468)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Transactions;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+
+namespace HeuristicLab.Services.Hive.DataAccess.Manager {
+  public class TransactionManager : ITransactionManager {
+    public void UseTransaction(Action call, bool repeatableRead = false, bool longRunning = false) {
+      int n = 10;
+      while (n > 0) {
+        TransactionScope transaction = CreateTransaction(repeatableRead, longRunning);
+        try {
+          call();
+          transaction.Complete();
+          n = 0;
+        }
+        catch (System.Data.SqlClient.SqlException e) {
+          n--; // probably deadlock situation, let it roll back and repeat the transaction n times
+          LogFactory.GetLogger(typeof(TransactionManager).Namespace).Log(string.Format("Exception occured, repeating transaction {0} more times. Details: {1}", n, e.ToString()));
+          if (n <= 0) throw;
+        }
+        finally {
+          transaction.Dispose();
+        }
+      }
+    }
+
+    public T UseTransaction<T>(Func<T> call, bool repeatableRead = false, bool longRunning = false) {
+      int n = 10;
+      while (n > 0) {
+        TransactionScope transaction = CreateTransaction(repeatableRead, longRunning);
+        try {
+          T result = call();
+          transaction.Complete();
+          n = 0;
+          return result;
+        }
+        catch (System.Data.SqlClient.SqlException e) {
+          n--; // probably deadlock situation, let it roll back and repeat the transaction n times
+          LogFactory.GetLogger(typeof(TransactionManager).Namespace).Log(string.Format("Exception occured, repeating transaction {0} more times. Details: {1}", n, e.ToString()));
+          if (n <= 0) throw;
+        }
+        finally {
+          transaction.Dispose();
+        }
+      }
+      throw new Exception("This code should not be reached");
+    }
+
+    private TransactionScope CreateTransaction(bool repeatableRead, bool longRunning) {
+      var options = new TransactionOptions();
+      if (repeatableRead)
+        options.IsolationLevel = IsolationLevel.RepeatableRead;
+      else
+        options.IsolationLevel = IsolationLevel.ReadUncommitted;
+
+      if (longRunning)
+        options.Timeout = Settings.Default.LongRunningDatabaseCommandTimeout;
+
+      return new TransactionScope(TransactionScopeOption.Required, options);
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Initialize Hive Database.sql	(revision 12468)
@@ -239,5 +239,5 @@
     [TotalMemory]           INT              NOT NULL,
     [CpuUtilization]        FLOAT (53)       NOT NULL,
-	[SlaveState]			VarChar(15) 	 NOT NULL,
+    [SlaveState]			VarChar(15) 	 NOT NULL,
     [TotalTimeIdle]         FLOAT (53)       NOT NULL,
     [TotalTimeCalculating]  FLOAT (53)       NOT NULL,
@@ -260,10 +260,10 @@
     [MemoryRequired]     INT              NOT NULL,
     [Priority]           INT              NOT NULL,
-    [LastClientId]       UNIQUEIDENTIFIER NOT NULL,
+    [LastClientId]       UNIQUEIDENTIFIER NULL,
     [JobId]              UNIQUEIDENTIFIER NOT NULL,
     [StartTime]          DATETIME         NOT NULL,
     [EndTime]            DATETIME         NULL,
-	[TaskState]          VARCHAR (30)     NOT NULL,
-	[Exception]			 VARCHAR (MAX)	  NULL,
+    [TaskState]          VARCHAR (30)     NOT NULL,
+    [Exception]			 VARCHAR (MAX)	  NULL,
     CONSTRAINT [PK_FactTask] PRIMARY KEY CLUSTERED ([TaskId] ASC),
     CONSTRAINT [FK_FactTask_DimClient] FOREIGN KEY ([LastClientId]) REFERENCES [statistics].[DimClient] ([Id]),
@@ -273,4 +273,5 @@
 );
 
-INSERT INTO [HeuristicLab.Hive-3.3].[statistics].[DimClient] ([Id] ,[Name] ,[ResourceId])
-VALUES ('00000000-0000-0000-0000-000000000000' ,'NULL' ,'00000000-0000-0000-0000-000000000000')
+/* dummy for nullable userIds in FactClientInfo */
+INSERT INTO [statistics].[DimUser] ([UserId], [Name])
+VALUES ('00000000-0000-0000-0000-000000000000', 'NULL');
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs	(revision 12468)
@@ -84,5 +84,5 @@
 
     overallCpuUtilizationLabel.Text = (onlineSlaves.Any() ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
-    cpuUtilizationLabel.Text = (onlineSlaves.Any() && onlineSlaves.Any(x => x.IsAllowedToCalculate) ? Math.Round(onlineSlaves.Where(x => x.IsAllowedToCalculate).Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
+    cpuUtilizationLabel.Text = (onlineSlaves.Any(x => x.IsAllowedToCalculate) ? Math.Round(onlineSlaves.Where(x => x.IsAllowedToCalculate).Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
 
     DT.Statistics[] stats = new DT.Statistics[0];
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 12468)
@@ -891,4 +891,5 @@
     public List<DT.UserStatistics> GetUserStatistics() {
       using (var db = CreateContext()) {
+        db.Log = Console.Out;
         var userStats = new Dictionary<Guid, DT.UserStatistics>();
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 12468)
@@ -23,4 +23,5 @@
 using System.Threading;
 using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 
 namespace HeuristicLab.Services.Hive {
@@ -30,5 +31,5 @@
     private AutoResetEvent generateStatisticsWaitHandle;
 
-    private DataAccess.ITransactionManager trans {
+    private ITransactionManager trans {
       get { return ServiceLocator.Instance.TransactionManager; }
     }
@@ -55,4 +56,5 @@
       stop = true;
       cleanupWaitHandle.Set();
+      generateStatisticsWaitHandle.Set();
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 12467)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 12468)
@@ -24,4 +24,5 @@
 using System.Linq;
 using System.ServiceModel;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
 using HeuristicLab.Services.Hive.DataTransfer;
 using HeuristicLab.Services.Hive.ServiceContracts;
@@ -51,5 +52,5 @@
       get { return ServiceLocator.Instance.AuthorizationManager; }
     }
-    private DataAccess.ITransactionManager trans {
+    private ITransactionManager trans {
       get { return ServiceLocator.Instance.TransactionManager; }
     }
